# Copyright (c) 2023 Hiroyuki Okada
# This software is released under the MIT License.
# http://opensource.org/licenses/mit-license.php
#version: "3.7"
services:
  ros-master:
    image: ros:noetic-ros-core
    command: roscore
    network_mode: "host"

  dev:
    image: okdhryk/whill-noetic:gpu
    build:
      context: .
      args:
      # ${VARIABLE} are defined in .env
        - USER_NAME=${USER_NAME}
        - GROUP_NAME=${GROUP_NAME}
        - PASSWORD=${PASSWORD}
        - UID=${UID}
        - GID=${GID}
        - ROBOT_NAME=${ROBOT_NAME}
        - WORKSPACE_DIR=${WORKSPACE_DIR}
        - NETWORK_IF=${NETWORK_IF}
    security_opt:
    - seccomp:unconfined
    deploy:
      resources:
        reservations:
          devices:
            - driver: nvidia
              capabilities:      
                - gpu
#                - utility # nvidia-smi
#                - compute # CUDA
#                - video   # NVDEC/NVENC/NVCUVID. For instance to use a hardware accelerated ffmpeg. Skip it if you don't need itk

    depends_on:
      - ros-master     
    environment:
      - DISPLAY=${DISPLAY}
      - NO_AT_BRIDGE=1
      - "TTY_WHILL=/dev/ttyUSB0"
#      - "ROS_HOSTNAME=dev"
      - "ROS_MASTER_URI=http://localhost:11311"
#    command: bash -c "bash"
    command: terminator
    volumes:
      - /sys/fs/cgroup:/sys/fs/cgroup:ro
      - /etc/passwd:/etc/passwd:ro
      - /etc/group:/etc/group:ro
      - /tmp/.X11-unix:/tmp/.X11-unix
      - ~/.Xauthority:/home/${USER_NAME}/.Xauthority
      - ${WORKSPACE_DIR}:${WORKSPACE_DIR}
      - /var/run/avahi-daemon/socket:/var/run/avahi-daemon/socket
    network_mode: host
    restart: always
    devices:
      - /dev/dri:/dev/dri
      - /dev/ttyUSB0:/dev/ttyUSB0
      #- /dev/ttyACM1:/dev/ttyACM1
      #- /dev/ttyACM2:/dev/ttyACM2
      - /dev/input:/dev/input

    ipc: host
    user: "${UID}:${GID}"
    tty: true
    stdin_open: true

  bringup:
    image: okdhryk/whill-noetic:gpu
    build:
      context: .
      args:
      # ${VARIABLE} are defined in .env
        - USER_NAME=${USER_NAME}
        - GROUP_NAME=${GROUP_NAME}
        - PASSWORD=${PASSWORD}
        - UID=${UID}
        - GID=${GID}
        - ROBOT_NAME=${ROBOT_NAME}
        - WORKSPACE_DIR=${WORKSPACE_DIR}
        - NETWORK_IF=${NETWORK_IF}
    security_opt:
    - seccomp:unconfined
    deploy:
      resources:
        reservations:
          devices:
            - driver: nvidia
              capabilities:      
                - gpu
#                - utility # nvidia-smi
#                - compute # CUDA
#                - video   # NVDEC/NVENC/NVCUVID. For instance to use a hardware accelerated ffmpeg. Skip it if you don't need itk

    depends_on:
      - ros-master     
    #hostname: bringup
    environment:
      - DISPLAY=${DISPLAY}
      - NO_AT_BRIDGE=1
      - "TTY_WHILL=/dev/ttyUSB0"
      - "ROS_MASTER_URI=http://localhost:11311"
    command: roslaunch whill_bringup urg.launch gui:=false
    volumes:
      - /sys/fs/cgroup:/sys/fs/cgroup:ro
      - /etc/passwd:/etc/passwd:ro
      - /etc/group:/etc/group:ro      
      - /tmp/.X11-unix:/tmp/.X11-unix
      - ~/.Xauthority:/home/${USER_NAME}/.Xauthority
      - ${WORKSPACE_DIR}:${WORKSPACE_DIR}
      - /var/run/avahi-daemon/socket:/var/run/avahi-daemon/socket
    network_mode: "host"
    restart: always
    devices:
      - /dev/dri:/dev/dri
      - /dev/ttyUSB0:/dev/ttyUSB0
#      - /dev/ttyACM1:/dev/ttyACM1
#      - /dev/ttyACM2:/dev/ttyACM2
      - /dev/input:/dev/input
      
    ipc: host
    user: "${UID}:${GID}"
    tty: true
    stdin_open: true
